<?php

namespace App\Security;

use App\Entity\User;
use Symfony\Component\Security\Core\Exception\CustomUserMessageAccountStatusException;
use Symfony\Component\Security\Core\User\UserCheckerInterface;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * Check if a user is valid for authentification
 */
class UserChecker implements UserCheckerInterface {
    /**
     * @inheritDoc
     */
    public function checkPreAuth (UserInterface $user): void {
        if (!$user instanceof User) {
            return;
        }

        if (!$user->isVerified()) {
            throw new CustomUserMessageAccountStatusException('Your account mail has not been validated.');
        }
        if ($user->getValidationAdministrator() === null || $user->getValidationDate() === null) {
            throw new CustomUserMessageAccountStatusException('Your account has not been validated by an administrator yet.');
        }
    }
    /**
     * @inheritDoc
     */
    public function checkPostAuth (UserInterface $user): void {
    }
}